#version 430 core
layout (triangles) in;
layout (triangle_strip, max_vertices = 3) out;

uniform mat4 modelMatrix;
uniform mat4 viewProjMatrix;
uniform mat3 normalMatrix;
uniform mat4 shadowViewProjMatrix;
uniform float time;

in VertexData {
    vec3 normal;
	vec2 uv;
} geo_in[];

out vec3 position_world;
out vec3 normal_world;
out vec2 uv;
out vec4 shadow_position;

void main(){
    vec3 firstVert = gl_in[0].gl_Position.xyz;
    vec3 secVert = gl_in[1].gl_Position.xyz;
    vec3 thirdVert =  gl_in[2].gl_Position.xyz;

    float displacement = 0.1f;

    firstVert.x = sin(time * 5.0f + firstVert.y * 2.0f) * displacement + firstVert.x;
    secVert.x = sin(time * 5.0f+ secVert.y * 2.0f) * displacement + secVert.x;
    thirdVert.x = sin(time * 5.0f + thirdVert.y * 2.0f) * displacement + thirdVert.x;

    firstVert = (modelMatrix * vec4(firstVert, 1.0f)).xyz;
    secVert = (modelMatrix * vec4(secVert, 1.0f)).xyz;
    thirdVert = (modelMatrix * vec4(thirdVert, 1.0f)).xyz;

    //recalculated normal (flat shaded)
    vec3 flat_normal = normalize(cross(firstVert - secVert, firstVert - thirdVert));

    position_world = firstVert;
    gl_Position = viewProjMatrix * vec4(firstVert, 1.0f);
    normal_world = geo_in[0].normal;
    shadow_position = shadowViewProjMatrix * vec4(firstVert, 1.0f);
    uv = geo_in[0].uv;
    EmitVertex();
    position_world = secVert;
    gl_Position = viewProjMatrix * vec4(secVert, 1.0f);
    normal_world = geo_in[1].normal;
    shadow_position = shadowViewProjMatrix * vec4(secVert, 1.0f);
    uv = geo_in[1].uv;
    EmitVertex();
    position_world = thirdVert;
    gl_Position = viewProjMatrix * vec4(thirdVert, 1.0f);
    normal_world = geo_in[2].normal;
    shadow_position = shadowViewProjMatrix * vec4(thirdVert, 1.0f);
    uv = geo_in[2].uv;
    EmitVertex();
}