#version 430 core

layout(location = 0) in vec3 position;
layout(location = 1) in vec3 normal;
layout(location = 2) in vec2 uv;

uniform mat4 modelMatrix;
uniform mat4 viewProjMatrix;
uniform mat3 normalMatrix;
uniform mat4 shadowViewProjMatrix;

out VertexData {
    vec3 normal;
	vec2 uv;
} vert;

void main() {
	vert.uv = uv;
    vert.normal = normalMatrix * normal;
	gl_Position = vec4(position, 1.0f);
}
