#version 430 core
layout (triangles) in;
layout (triangle_strip, max_vertices = 3) out;

uniform mat4 modelMatrix;
uniform mat4 shadowViewProjMatrix;
uniform float time;

in gl_PerVertex
{
  vec4 gl_Position;
} gl_in[];

void main(){
    vec3 firstVert = gl_in[0].gl_Position.xyz;
    vec3 secVert = gl_in[1].gl_Position.xyz;
    vec3 thirdVert =  gl_in[2].gl_Position.xyz;

    float displacement = 0.1f;

    firstVert.x = sin(time * 5.0f + firstVert.y * 2.0f) * displacement + firstVert.x;
    secVert.x = sin(time * 5.0f+ secVert.y * 2.0f) * displacement + secVert.x;
    thirdVert.x = sin(time * 5.0f + thirdVert.y * 2.0f) * displacement + thirdVert.x;

    firstVert = (modelMatrix * vec4(firstVert, 1.0f)).xyz;
    secVert = (modelMatrix * vec4(secVert, 1.0f)).xyz;
    thirdVert = (modelMatrix * vec4(thirdVert, 1.0f)).xyz;

    gl_Position = shadowViewProjMatrix * vec4(firstVert, 1.0f);
    EmitVertex();
    gl_Position = shadowViewProjMatrix * vec4(secVert, 1.0f);
    EmitVertex();
    gl_Position = shadowViewProjMatrix * vec4(thirdVert, 1.0f);
    EmitVertex();
}